// sound
// subsim (C)+(W) Markus Petermann and Thorsten Jordan. SEE LICENSE

#ifndef _SOUND_H_
#define _SOUND_H_

#include <SDL.h>
#include <SDL_mixer.h>
#include "angle.h"
#include "sea_object.h"

class sound
{
public:
	sound(const string& filename);
	~sound();
	void play(float volume = 1.0f) const;	
	void play(const sea_object* player, const sea_object* noise_source, const bool loop_forever = false);
	void play_fade(const sea_object* player, const sea_object* noise_source, const bool loop_forever = false);
	void stop();
	void fade_out();

	static bool use_sound;	// set this to enable/disable sound

	static void init(void);
	static void deinit(void);
	
	void pause();
	void resume();
	void pause_all();
	void resume_all();

protected:
	sound();
	sound(const sound& );
	sound& operator= (const sound& );

	Mix_Chunk* mixchunk;
	int channel_num;
	
private:
	void _play(const sea_object* player, const sea_object* noise_source, const bool loop_forever, const bool fade);
};

#endif /* _SOUND_H_ */
