// A tokenizer
// subsim (C)+(W) Thorsten Jordan. SEE LICENSE

#ifndef TOKENIZER_H
#define TOKENIZER_H

#include <fstream>
#include <string>
#include <vector>
using namespace std;

#include "token.h"

class tokenizer
{
	ifstream inputstr;
	vector<token> tokenlist;
	token current, previous;
	int token_none, token_string, token_number, token_id;
	unsigned line, column;
	
	public:
	tokenizer(const string& filename, vector<token>& tokenlist_,
		int token_none_=-1, int token_string_=-2,
		int token_number_=-3, int token_id_=-4);
	token get_current(void) const { return current; };
	token get_previous(void) const { return previous; };
	bool is_empty(void) const { return current.is_empty(); };
	unsigned get_line(void) const { return line; };
	unsigned get_column(void) const { return column-current.text.length()+1; };
	void count(char c);
	token read_next(void);
};	

#endif
