// (ocean) water simulation and display (OpenGL)
// subsim (C)+(W) Thorsten Jordan. SEE LICENSE

// special optimized SSE routines.

#ifndef WATER_SSE_H
#define WATER_SSE_H

#ifdef USE_SSE

#include <SDL_types.h>
#include "vector2.h"

bool x86_sse_supported();

void water_compute_coord_init_sse(float wavetile_length_rcp, unsigned wave_resolution,
				  unsigned wave_resolution_shift);

void water_compute_coord_1line_sse(const vector2f& v, const vector2f& vadd,
				   const vector2f& vfrac, const vector2f& vfracadd,
				   const Uint32* tiledata_baseptr, float minusviewposz,
				   float* coordptr, unsigned xres);

#endif
#endif
